KAboutDialog Class Reference

`#include <kaboutdialog.h>`

Inheritance diagram for KAboutDialog:

## Public Types

enum | LayoutType { AbtPlain = 0x0001, AbtTabbed = 0x0002, AbtTitle = 0x0004, AbtImageLeft = 0x0008, AbtImageRight = 0x0010, AbtImageOnly = 0x0020, AbtProduct = 0x0040, AbtKDEStandard = AbtTabbed|AbtTitle|AbtImageLeft, AbtAppStandard = AbtTabbed|AbtTitle|AbtProduct, AbtImageAndTitle = AbtPlain|AbtTitle|AbtImageOnly }
Public Types inherited from KDialogBase
enum | ButtonCode { Help = 0x00000001, Default = 0x00000002, Ok = 0x00000004, Apply = 0x00000008, Try = 0x00000010, Cancel = 0x00000020, Close = 0x00000040, User1 = 0x00000080, User2 = 0x00000100, User3 = 0x00000200, No = 0x00000080, Yes = 0x00000100, Details = 0x00000400, Filler = 0x40000000, Stretch = 0x80000000, NoDefault }
enum | ActionButtonStyle { ActionStyle0 =0, ActionStyle1, ActionStyle2, ActionStyle3, ActionStyle4, ActionStyleMAX }
enum | DialogType { TreeList = KJanusWidget::TreeList, Tabbed = KJanusWidget::Tabbed, Plain = KJanusWidget::Plain, Swallow = KJanusWidget::Swallow, IconList = KJanusWidget::IconList }

## Signals

void | sendEmail (const QString &name, const QString &email)
void | openURL (const QString &url)
Signals inherited from KDialogBase
void | helpClicked ()
void | defaultClicked ()
void | user3Clicked ()
void | user2Clicked ()
void | user1Clicked ()
void | applyClicked ()
void | tryClicked ()
void | okClicked ()
void | yesClicked ()
void | noClicked ()
void | cancelClicked ()
void | closeClicked ()
void | apply ()
void | backgroundChanged ()
void | hidden ()
void | finished ()
void | aboutToShowDetails ()
void | aboutToShowPage (QWidget *page)
Signals inherited from KDialog
void | layoutHintChanged ()

## Public Member Functions

| KAboutDialog (QWidget *parent=0, const char *name=0, bool modal=true)
| KAboutDialog (int dialogLayout, const QString &caption, int buttonMask, ButtonCode defaultButton, QWidget *parent=0, const char *name=0, bool modal=false, bool separator=false, const QString &user1=QString::null, const QString &user2=QString::null, const QString &user3=QString::null)
void | adjust ()
virtual void | show (void)
virtual void | show (QWidget *centerParent)
void | setTitle (const QString &title)
void | setImage (const QString &fileName)
void | setIcon (const QString &fileName) KDE_DEPRECATED
void | setProgramLogo (const QString &fileName)
void | setProgramLogo (const QPixmap &pixmap)
void | setImageBackgroundColor (const QColor &color)
void | setImageFrame (bool state)
void | setProduct (const QString &appName, const QString &version, const QString &author, const QString &year)
QFrame * | addTextPage (const QString &title, const QString &text, bool richText=false, int numLines=10)
QFrame * | addLicensePage (const QString &title, const QString &text, int numLines=10)
KAboutContainer * | addContainerPage (const QString &title, int childAlignment=AlignCenter, int innerAlignment=AlignCenter)
KAboutContainer * | addScrolledContainerPage (const QString &title, int childAlignment=AlignCenter, int innerAlignment=AlignCenter)
KAboutContainer * | addContainer (int childAlignment, int innerAlignment)
QFrame * | addPage (const QString &title)
void | setLogo (const QPixmap &)
void | setAuthor (const QString &name, const QString &email, const QString &url, const QString &work)
void | setMaintainer (const QString &name, const QString &email, const QString &url, const QString &work)
void | addContributor (const QString &name, const QString &email, const QString &url, const QString &work)
void | setVersion (const QString &name)
Public Member Functions inherited from KDialogBase
| KDialogBase (QWidget *parent=0, const char *name=0, bool modal=true, const QString &caption=QString::null, int buttonMask=Ok|Apply|Cancel, ButtonCode defaultButton=Ok, bool separator=false, const KGuiItem &user1=KGuiItem(), const KGuiItem &user2=KGuiItem(), const KGuiItem &user3=KGuiItem())
| KDialogBase (int dialogFace, const QString &caption, int buttonMask, ButtonCode defaultButton, QWidget *parent=0, const char *name=0, bool modal=true, bool separator=false, const KGuiItem &user1=KGuiItem(), const KGuiItem &user2=KGuiItem(), const KGuiItem &user3=KGuiItem())
| KDialogBase (KDialogBase::DialogType dialogFace, WFlags f, QWidget *parent=0, const char *name=0, bool modal=true, const QString &caption=QString::null, int buttonMask=Ok|Apply|Cancel, ButtonCode defaultButton=Ok, bool separator=false, const KGuiItem &user1=KGuiItem(), const KGuiItem &user2=KGuiItem(), const KGuiItem &user3=KGuiItem())
| KDialogBase (const QString &caption, int buttonMask=Yes|No|Cancel, ButtonCode defaultButton=Yes, ButtonCode escapeButton=Cancel, QWidget *parent=0, const char *name=0, bool modal=true, bool separator=false, const KGuiItem &yes=KStdGuiItem::yes(), const KGuiItem &no=KStdGuiItem::no(), const KGuiItem &cancel=KStdGuiItem::cancel())
| ~KDialogBase ()
void | setButtonBoxOrientation (int orientation)
void | setEscapeButton (ButtonCode id)
virtual void | adjustSize ()
virtual QSize | sizeHint () const
virtual QSize | minimumSizeHint () const
QFrame * | plainPage ()
QFrame * | addPage (const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QFrame * | addPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QVBox * | addVBoxPage (const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QVBox * | addVBoxPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QHBox * | addHBoxPage (const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QHBox * | addHBoxPage (const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QGrid * | addGridPage (int n, Orientation dir, const QString &itemName, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
QGrid * | addGridPage (int n, Orientation dir, const QStringList &items, const QString &header=QString::null, const QPixmap &pixmap=QPixmap())
void | setFolderIcon (const QStringList &path, const QPixmap &pixmap)
QFrame * | makeMainWidget ()
QVBox * | makeVBoxMainWidget ()
QHBox * | makeHBoxMainWidget ()
QGrid * | makeGridMainWidget (int n, Orientation dir)
void | enableButtonSeparator (bool state)
void | showButton (ButtonCode id, bool state)
void | showButtonOK (bool state)
void | showButtonApply (bool state)
void | showButtonCancel (bool state)
bool | showPage (int index)
int | activePageIndex () const
int | pageIndex (QWidget *widget) const
void | setMainWidget (QWidget *widget)
QWidget * | mainWidget ()
void | disableResize ()
void | setInitialSize (const QSize &s, bool noResize=false)
void | incInitialSize (const QSize &s, bool noResize=false)
QSize | configDialogSize (const QString &groupName) const
QSize | configDialogSize (KConfig &config, const QString &groupName) const
void | saveDialogSize (const QString &groupName, bool global=false)
void | saveDialogSize (KConfig &config, const QString &groupName, bool global=false) const
void | setButtonOK (const KGuiItem &item=KStdGuiItem::ok())
void | setButtonOKText (const QString &text=QString::null, const QString &tooltip=QString::null, const QString &quickhelp=QString::null) KDE_DEPRECATED
void | setButtonApply (const KGuiItem &item=KStdGuiItem::apply())
void | setButtonApplyText (const QString &text=QString::null, const QString &tooltip=QString::null, const QString &quickhelp=QString::null) KDE_DEPRECATED
void | setButtonCancel (const KGuiItem &item=KStdGuiItem::cancel())
void | setButtonCancelText (const QString &text=QString::null, const QString &tooltip=QString::null, const QString &quickhelp=QString::null) KDE_DEPRECATED
void | setButtonText (ButtonCode id, const QString &text)
void | setButtonTip (ButtonCode id, const QString &text)
void | setButtonWhatsThis (ButtonCode id, const QString &text)
void | setButtonGuiItem (ButtonCode id, const KGuiItem &item)
void | setTreeListAutoResize (bool state)
void | setShowIconsInTreeList (bool state)
void | setRootIsDecorated (bool state)
void | unfoldTreeList (bool persist=false)
void | addWidgetBelowList (QWidget *widget)
void | addButtonBelowList (const QString &text, QObject *recv, const char *slot)
void | addButtonBelowList (const KGuiItem &guiitem, QObject *recv, const char *slot)
void | setIconListAllVisible (bool state)
void | showTile (bool state)
void | getBorderWidths (int &ulx, int &uly, int &lrx, int &lry) const KDE_DEPRECATED
QRect | getContentsRect () const KDE_DEPRECATED
QSize | calculateSize (int w, int h) const
QString | helpLinkText () const
QPushButton * | actionButton (ButtonCode id)
Public Member Functions inherited from KDialog
| KDialog (QWidget *parent=0, const char *name=0, bool modal=false, WFlags f=0)

## Static Public Member Functions

static void | imageURL (QWidget *parent, const QString &caption, const QString &path, const QColor &imageColor, const QString &url)
Static Public Member Functions inherited from KDialogBase
static bool | haveBackgroundTile ()
static const QPixmap * | backgroundTile ()
static const QPixmap * | getBackgroundTile () KDE_DEPRECATED
static void | setBackgroundTile (const QPixmap *pix)
Static Public Member Functions inherited from KDialog
static int | marginHint ()
static int | spacingHint ()
static void | resizeLayout (QWidget *widget, int margin, int spacing)
static void | resizeLayout (QLayoutItem *lay, int margin, int spacing)
static void | centerOnScreen (QWidget *widget, int screen=-1)
static bool | avoidArea (QWidget *widget, const QRect &area, int screen=-1)

## Protected Slots

void | sendEmailSlot (const QString &name, const QString &email)
void | openURLSlot (const QString &url)
virtual void | mouseTrackSlot (int mode, const QMouseEvent *e)
Protected Slots inherited from KDialogBase
virtual void | slotHelp ()
virtual void | slotDefault ()
virtual void | slotDetails ()
virtual void | slotUser3 ()
virtual void | slotUser2 ()
virtual void | slotUser1 ()
virtual void | slotOk ()
virtual void | slotApply ()
virtual void | slotTry ()
virtual void | slotYes ()
virtual void | slotNo ()
virtual void | slotCancel ()
virtual void | slotClose ()
virtual void | applyPressed ()
void | updateGeometry ()
void | slotDelayedDestruct ()

## Protected Member Functions

virtual void | virtual_hook (int id, void *data)
Protected Member Functions inherited from KDialogBase
virtual void | keyPressEvent (QKeyEvent *e)
virtual void | hideEvent (QHideEvent *)
virtual void | closeEvent (QCloseEvent *e)

## Protected Attributes

KAboutWidget * | about
KAboutContainerBase * | mContainerBase

## Additional Inherited Members

Public Slots inherited from KDialogBase
void | enableButton (ButtonCode id, bool state)
void | enableButtonOK (bool state)
void | enableButtonApply (bool state)
void | enableButtonCancel (bool state)
void | enableLinkedHelp (bool state)
void | delayedDestruct ()
void | setHelpLinkText (const QString &text)
void | setHelp (const QString &anchor, const QString &appname=QString::null)
void | helpClickedSlot (const QString &)
void | setDetails (bool showDetails)
void | setDetailsWidget (QWidget *detailsWidget)
void | updateBackground ()
void | cancel ()
Public Slots inherited from KDialog
virtual void | polish ()
virtual void | setCaption (const QString &caption)
virtual void | setPlainCaption (const QString &caption)

## Detailed Description

A KDialogBase with predefined main widget.

As a KDialogBase it uses your application wide settings for KDialogBase objects (base frame tiles, main frame tiles etc). To use it, simply create a KAboutDialog object, set all (or some) of its properties and show it. Do not derive it to create your own about dialog until you need some cool features that are unsupported and you have contacted me to add them.

The dialog can be created using two different constructors. The difference between these constructors is the available components that can be used to build the contents of the dialog. The first (Constructor I) provides a number of easy to use methods. Basically it allows you to add the components of choice, and the components are placed in a predefined layout. You do not have to plan the layout. Everything is taken care of.

The second constructor (Constructor II) works in quite the same manner as the first, but you have better control on where the components are postioned in the layout and you have access to an extended number of components you can install such as titles, product information, a tabbed pages (where you can display rich text with url links) and a person (developer) information field. The "About KDE" dialog box is created with Constructor II.

For the derived features, see the basic class KDialogBase.

Author
  Mirko Boehm (mirko.nosp@m.@kde.nosp@m..org) and Espen Sand (espen.nosp@m.sa@o.nosp@m.nline.nosp@m..no)

See also
  KDialogBase

Definition at line 283 of file kaboutdialog.h.

## Member Enumeration Documentation

enum KAboutDialog::LayoutType

Layout formats.

Definition at line 291 of file kaboutdialog.h.

## Constructor & Destructor Documentation

KAboutDialog::KAboutDialog | ( | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | bool | modal = `true`
| ) |  |

The standard Qt constructor (Constructor I).

Add components with the following methods: setLogo(), setAuthor(), setMaintainer(), addContributor(), or setVersion(). The dialog will be laid out automatically.

Definition at line 1506 of file kaboutdialog.cpp.

KAboutDialog::KAboutDialog | ( | int | dialogLayout,
|  | const QString & | caption,
|  | int | buttonMask,
|  | ButtonCode | defaultButton,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | bool | modal = `false`,
|  | bool | separator = `false`,
|  | const QString & | user1 = `QString::null`,
|  | const QString & | user2 = `QString::null`,
|  | const QString & | user3 = `QString::null`
| ) |  |

The extended constructor.

(Constructor II).

Add components with the methods: setTitle(), setImage(), setImageBackgroundColor(), setImageFrame(), setProduct(), addTextPage(), addContainerPage(), addContainer(), or addPage().

Parameters

  dialogLayout | Use a mask of LayoutType flags.
  caption | The dialog caption. The text you specify is prepended by i18n("About").
  buttonMask | Specifies what buttons will be visible.
  defaultButton | Specifies what button will be marked as the default.
  parent | Parent of the dialog.
  name | Dialog name (for internal use only)
  modal | Sets dialog modality. If false, the rest of the program interface (other dialogs, for example) is accessible while the dialog is open.
  separator | If true, a separator line is drawn between the action buttons an the main widget.
  user1 | User button1 text.
  user2 | User button2 text.
  user3 | User button3 text.

Definition at line 1526 of file kaboutdialog.cpp.

## Member Function Documentation

KAboutContainer * KAboutDialog::addContainer | ( | int | childAlignment,
|  | int | innerAlignment
| ) |  |

(Constructor II only) Adds a container.

You can add text and images to a container.

Parameters

  childAlignment | Specifies how the children of the container are aligned with respect to the container.
  innerAlignment | Specifies how the children are aligned with respect to each other.

Returns
  The new container.

Definition at line 1683 of file kaboutdialog.cpp.

KAboutContainer * KAboutDialog::addContainerPage | ( | const QString & | title,
|  | int | childAlignment = `AlignCenter`,
|  | int | innerAlignment = `AlignCenter`
| ) |  |

(Constructor II only) Adds a container to a tab box.

You can add text and images to a container.

Parameters

  title | Tab name.
  childAlignment | Specifies how the children of the container are aligned with respect to the container.
  innerAlignment | Specifies how the children are aligned with respect to each other.

Returns
  The new container.

Definition at line 1657 of file kaboutdialog.cpp.

void KAboutDialog::addContributor | ( | const QString & | name,
|  | const QString & | email,
|  | const QString & | url,
|  | const QString & | work
| ) |  |

(Constructor I only) Show this person as one of the major contributors.

Definition at line 1599 of file kaboutdialog.cpp.

QFrame * KAboutDialog::addLicensePage | ( | const QString & | title,
|  | const QString & | text,
|  | int | numLines = `10`
| ) |  |

(Constructor II only) Adds a license page to a tab box.

Parameters

  title | Tab name.
  text | The text to display.
  numLines | The text area height will be adjusted so that this is the minimum number of lines of text that are visible.

Returns
  The frame that contains the page.

Definition at line 1649 of file kaboutdialog.cpp.

QFrame * KAboutDialog::addPage | ( | const QString & | title | ) |

(Constructor II only) Adds an empty page to a tab box.

Parameters

  title | Tab name

Returns
  The new page.

Definition at line 1676 of file kaboutdialog.cpp.

KAboutContainer * KAboutDialog::addScrolledContainerPage | ( | const QString & | title,
|  | int | childAlignment = `AlignCenter`,
|  | int | innerAlignment = `AlignCenter`
| ) |  |

(Constructor II only) Adds a container inside a QScrollView to a tab box.

You can add text and images to a container.

Parameters

  title | Tab name.
  childAlignment | Specifies how the children of the container are aligned with respect to the container.
  innerAlignment | Specifies how the children are aligned with respect to each other.

Returns
  The new container.

Definition at line 1666 of file kaboutdialog.cpp.

QFrame * KAboutDialog::addTextPage | ( | const QString & | title,
|  | const QString & | text,
|  | bool | richText = `false`,
|  | int | numLines = `10`
| ) |  |

(Constructor II only) Adds a text page to a tab box.

The text can be regular text or rich text. The rich text can contain URLs and mail links.

Parameters

  title | Tab name.
  text | The text to display.
  richText | Set this to `true` if 'text' is rich text.
  numLines | The text area height will be adjusted so that this is the minimum number of lines of text that are visible.

Returns
  The frame that contains the page.

Definition at line 1642 of file kaboutdialog.cpp.

void KAboutDialog::adjust | ( |  | ) |

Adjusts the dialog.

You can call this method after you have set up all the contents but it is not required. It is done automatically when show() is executed.

Definition at line 1565 of file kaboutdialog.cpp.

void KAboutDialog::imageURL | ( | QWidget * | parent,
|  | const QString & | caption,
|  | const QString & | path,
|  | const QColor & | imageColor,
|  | const QString & | url
| ) |  |

static

Create a modal dialog with an image in the upper area with a URL link below.

Definition at line 1746 of file kaboutdialog.cpp.

void KAboutDialog::mouseTrackSlot | ( | int | mode,
|  | const QMouseEvent * | e
| ) |  |

protected virtual slot

(Constructor II only) Tells the position of the mouse cursor when the left mouse button is pressed above an image

Definition at line 1636 of file kaboutdialog.cpp.

void KAboutDialog::openURL | ( | const QString & | url | ) |

signal

Open the selected URL.

void KAboutDialog::openURLSlot | ( | const QString & | url | ) |

protected slot

Open this URL.

Definition at line 1627 of file kaboutdialog.cpp.

void KAboutDialog::sendEmail | ( | const QString & | name,
|  | const QString & | email
| ) |  |

signal

Send an email to this person.

The application must provide the functionality.

void KAboutDialog::sendEmailSlot | ( | const QString & | name,
|  | const QString & | email
| ) |  |

protected slot

Connected to widget->sendEmail.

Definition at line 1616 of file kaboutdialog.cpp.

void KAboutDialog::setAuthor | ( | const QString & | name,
|  | const QString & | email,
|  | const QString & | url,
|  | const QString & | work
| ) |  |

(Constructor I only) Sets the author's name and email address.

Definition at line 1590 of file kaboutdialog.cpp.

void KAboutDialog::setIcon | ( | const QString & | fileName | ) |

(Constructor II only) Define the program logo to be shown in the dialog.

Use this to override the default program logo. For example, use this function if the KAboutDialog is for a panel applet and you want to override the appletproxy logo with your own pixmap.

Parameters

  fileName | Path to file containing logo data in a format that can be loaded by QPixmap.

Since
  3.3

Definition at line 1705 of file kaboutdialog.cpp.

void KAboutDialog::setImage | ( | const QString & | fileName | ) |

(Constructor II only) Define an image to be shown in the dialog.

The position is dependent on the `dialogLayout` in the constructor

Parameters

  fileName | Path to image file.

Definition at line 1698 of file kaboutdialog.cpp.

void KAboutDialog::setImageBackgroundColor | ( | const QColor & | color | ) |

(Constructor II only) The image has a minimum size, but is centered within an area if the dialog box is enlarged by the user.

You set the background color of the area with this method.

Parameters

  color | Background color.

Definition at line 1723 of file kaboutdialog.cpp.

void KAboutDialog::setImageFrame | ( | bool | state | ) |

(Constructor II only) Enables or disables a frame around the image.

The frame is, by default, enabled in the constructor

Parameters

  state | A value of `true` enables the frame

Definition at line 1730 of file kaboutdialog.cpp.

void KAboutDialog::setLogo | ( | const QPixmap & | i | ) |

(Constructor I only) Sets the image as the application logo.

Definition at line 1574 of file kaboutdialog.cpp.

void KAboutDialog::setMaintainer | ( | const QString & | name,
|  | const QString & | email,
|  | const QString & | url,
|  | const QString & | work
| ) |  |

(Constructor I only) Sets the maintainer's name and email address.

Definition at line 1581 of file kaboutdialog.cpp.

void KAboutDialog::setProduct | ( | const QString & | appName,
|  | const QString & | version,
|  | const QString & | author,
|  | const QString & | year
| ) |  |

(Constructor II only) Prints the application name, KDE version, author, a copyright sign and a year string.

To the left of the text the standard application icon is displayed.

Parameters

  appName | The application name.
  version | Application version.
  author | One or more authors.
  year | A string telling when the application was made.

Definition at line 1737 of file kaboutdialog.cpp.

void KAboutDialog::setProgramLogo | ( | const QString & | fileName | ) |

Overloaded version of setProgramLogo(const QPixmap& pixmap).

Since
  3.4

Definition at line 1711 of file kaboutdialog.cpp.

void KAboutDialog::setProgramLogo | ( | const QPixmap & | pixmap | ) |

(Constructor II only) Define the program logo to be shown in the dialog.

Use this to override the default program logo. For example, use this function if the KAboutDialog is for a panel applet and you want to override the appletproxy logo with your own pixmap.

Parameters

  pixmap | The logo pixmap.

Since
  3.4

Definition at line 1717 of file kaboutdialog.cpp.

void KAboutDialog::setTitle | ( | const QString & | title | ) |

(Constructor II only) Sets a title (not caption) in the uppermost area of the dialog.

Parameters

  title | Title string.

Definition at line 1691 of file kaboutdialog.cpp.

void KAboutDialog::setVersion | ( | const QString & | name | ) |

(Constructor I only) Sets the text describing the version.

Definition at line 1608 of file kaboutdialog.cpp.

void KAboutDialog::show | ( | void |  | ) |

virtual

Makes a modeless (modal = false in constructor) dialog visible.

If you reimplement this method make sure you run it in the new method (e.g., show()). Reimplemented from KDialogBase.

Definition at line 1549 of file kaboutdialog.cpp.

void KAboutDialog::show | ( | QWidget * | centerParent | ) |

virtual

Makes a modeless (modal = false in constructor) dialog visible.

If you reimplmement this method make sure you run it in the new method (i.e., show( parent )).

Parameters

  centerParent | Center the dialog with respect to this widget.

Definition at line 1557 of file kaboutdialog.cpp.

## Member Data Documentation

KAboutWidget* KAboutDialog::about

protected

The main widget (Constructor I)

Definition at line 599 of file kaboutdialog.h.

KAboutContainerBase* KAboutDialog::mContainerBase

protected

The main widget (Constructor II)

Definition at line 604 of file kaboutdialog.h.

The documentation for this class was generated from the following files:

- kaboutdialog.h
- kaboutdialog.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys